- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# csvfile – read data from a TSV or CSV file

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- The csvfile lookup reads the contents of a file in CSV (comma-separated value) format. The lookup looks for the row where the first column matches keyname, and returns the value in the second column, unless a different column is specified.

## Parameters

Parameter | Choices/Defaults | Configuration | Comments
--- | --- | --- | ---
col - | Default: "1" |  | column to return (0 index).
default - | Default: "" |  | what to return if the value is not found in the file.
delimiter - | Default: "TAB" |  | field separator in the file, for a tab you can specify "TAB" or "t".
encoding - | Default: "utf-8" |  | Encoding (character set) of the used CSV file.
file - | Default: "ansible.csv" |  | name of the CSV/TSV file to open.

## Notes

Note

- The default is for TSV files (tab delimited) not CSV (comma delimited) ... yes the name is misleading.

## Examples

    - name:  Match 'Li' on the first column, return the second column (0 based index)
      debug: msg="The atomic number of Lithium is {{ lookup('csvfile', 'Li file=elements.csv delimiter=,') }}"

    - name: msg="Match 'Li' on the first column, but return the 3rd column (columns start counting after the match)"
      debug: msg="The atomic mass of Lithium is {{ lookup('csvfile', 'Li file=elements.csv delimiter=, col=2') }}"

    - name: Define Values From CSV File
      set_fact:
        loop_ip: "{{ lookup('csvfile', bgp_neighbor_ip +' file=bgp_neighbors.csv delimiter=, col=1') }}"
        int_ip: "{{ lookup('csvfile', bgp_neighbor_ip +' file=bgp_neighbors.csv delimiter=, col=2') }}"
        int_mask: "{{ lookup('csvfile', bgp_neighbor_ip +' file=bgp_neighbors.csv delimiter=, col=3') }}"
        int_name: "{{ lookup('csvfile', bgp_neighbor_ip +' file=bgp_neighbors.csv delimiter=, col=4') }}"
        local_as: "{{ lookup('csvfile', bgp_neighbor_ip +' file=bgp_neighbors.csv delimiter=, col=5') }}"
        neighbor_as: "{{ lookup('csvfile', bgp_neighbor_ip +' file=bgp_neighbors.csv delimiter=, col=6') }}"
        neigh_int_ip: "{{ lookup('csvfile', bgp_neighbor_ip +' file=bgp_neighbors.csv delimiter=, col=7') }}"
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this lookup:

Key | Returned | Description
--- | --- | ---
_raw - |  | value(s) stored in file column

## Status

- This lookup is not guaranteed to have a backwards compatible interface. [preview]
- This lookup is maintained by the Ansible Community. [community]

### Authors

- Jan-Piet Mens (@jpmens) <jpmens(at)gmail.com>

Hint

If you notice any issues in this documentation, you can edit this document to improve it.

Hint

Configuration entries for each entry type have a low to high priority order. For example, a variable that is lower in the list will override a variable that is higher up.